﻿
﻿package {
    import flash.events.*;
    import flash.display.*;
    import flash.text.*;
    import flash.utils.*;

    public class PaperWarfare extends MovieClip {

        public var showShots:TextField;
        public var showScore:TextField;
        //private var cannon:Cannon;
        private var airplanes:Array;
        private var bullets:Array;
        public var leftArrow;
        public var rightArrow:Boolean;
        private var nextPlane:Timer;
        private var ammo:int;
        private var score:int;

        public function startGame(){
            ammo = 100;
            score = 0;
            showGameScore();
            airplanes = new Array();
            bullets = new Array();
            stage.addEventListener(KeyboardEvent.KEY_DOWN, keyDownFunction);
            stage.addEventListener(KeyboardEvent.KEY_UP, keyUpFunction);
            addEventListener(Event.ENTER_FRAME, checkForHits);
            setNextPlane();
        }
        public function setNextPlane(){
            nextPlane = new Timer((1000 + (Math.random() * 1000)), 1);
            nextPlane.addEventListener(TimerEvent.TIMER_COMPLETE, newPlane);
            nextPlane.start();
        }
        public function newPlane(e:TimerEvent){
            var dir:String;
            if (Math.random() > 0.5){
                dir = "left";
            } else {
                dir = "right";
            };
            var alt:Number = ((Math.random() * 50) + 20);
            var speed:Number = ((Math.random() * 100) + 100);
            var plane:Airplane = new Airplane(dir, speed, alt);
            addChild(plane);
            airplanes.push(plane);
            setNextPlane();
        }
        public function checkForHits(e:Event){
            var planes_max:int; // TODO FOR
            var bullet_max:int = (bullets.length - 1);
            while (bullet_max >= 0) {
                planes_max = (airplanes.length - 1);
                while (planes_max >= 0) {
                    if (bullets[bullet_max].hitTestObject(airplanes[planes_max])){
                        airplanes[planes_max].planeHit();
                        bullets[bullet_max].deleteBullet();
                        score++;
                        showGameScore();
                        break;
                    };
                    planes_max--;
                };
                bullet_max--;
            };
            if ((ammo == 0) && (bullets.length == 0)){
                endGame();
            };
        }
        public function keyDownFunction(e:KeyboardEvent){
            if (e.keyCode == 37) {
                leftArrow = true;
            } else {
                if (e.keyCode == 39) {
                    rightArrow = true;
                } else {
                    if (e.keyCode == 32) {
                        fireBullet();
                    };
                };
            };
        }
        public function keyUpFunction(e:KeyboardEvent){
            if (e.keyCode == 37) {
                leftArrow = false;
            } else {
                if (e.keyCode == 39) {
                    rightArrow = false;
                };
            };
        }
        public function fireBullet(){
            if (ammo <= 0){
                return;
            }
            var new_bullet:Bullet = new Bullet(cannon.x, cannon.y, cannon.rotation, 300);
            addChild(new_bullet);
            bullets.push(new_bullet);
            ammo--;
            showGameScore();
        }
        public function showGameScore(){
            showScore.text = "Wynik: " + score;
            showAmmo.text = "Spinacze: " + ammo;
        }
        public function removePlane(a:Airplane){
            var plane;
            for (plane in airplanes) {
                if (airplanes[plane] == a){
                    airplanes.splice(plane, 1);
                    break;
                };
            };
        }
        public function removeBullet(b:Bullet){
            var bull;
            for (bull in bullets) {
                if (bullets[bull] == b){
                    bullets.splice(bull, 1);
                    break;
                };
            };
        }
        public function endGame(){
            var airplanes_left:int = (airplanes.length - 1);
            while (airplanes_left >= 0) {
                airplanes[airplanes_left].deletePlane();
                airplanes_left--;
            };
            airplanes = null;
            cannon.deleteCannon();
            cannon = null;
            stage.removeEventListener(KeyboardEvent.KEY_DOWN, keyDownFunction);
            stage.removeEventListener(KeyboardEvent.KEY_UP, keyUpFunction);
            removeEventListener(Event.ENTER_FRAME, checkForHits);
            nextPlane.stop();
            nextPlane = null;
            gotoAndStop(3);
        }
    }
}//package